﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Text;
using System.Drawing;
using System.IO;
using System.Reflection;

namespace Mfe
{
    public partial class HelpWindow : Form
    {
        public MasterWindow Master;

        public HelpWindow(MasterWindow master)
        {
            Master = master;
            InitializeComponent();
            this.MdiParent = Master;
            this.Show();
            if (!editingBox.Visible)
            {
                currentItemRichTextBox.ReadOnly = true;
                //currentItemRichTextBox.Enabled = false;
            }
            //currentItemRichTextBox.Rtf = 
            //UnmanagedMemoryStream stream = (UnmanagedMemoryStream)Assembly.GetExecutingAssembly().GetManifestResourceStream(Type.GetType("byte[]"), resourceName);
            UnmanagedMemoryStream stream = (UnmanagedMemoryStream)Assembly.GetExecutingAssembly().GetManifestResourceStream("Mfe.Help.overview.rtf");
            byte[] data = new byte[stream.Length];
            stream.Read(data, 0, (int)stream.Length);
            StringBuilder str = new StringBuilder((int)stream.Length);
            for (int i = 0; i < data.Length; i++)
                str.Append((char)data[i]);
            currentItemRichTextBox.Rtf = str.ToString();

        }

        private void HelpWindow_FormClosing(object sender, FormClosingEventArgs e)
        {
            Master.HelpWindow = null;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (saveFileDialog.ShowDialog() != System.Windows.Forms.DialogResult.OK)
                return;
            currentItemRichTextBox.SaveFile(saveFileDialog.FileName);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (openFileDialog.ShowDialog() != System.Windows.Forms.DialogResult.OK)
                return;
            currentItemRichTextBox.LoadFile(openFileDialog.FileName);
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            currentItemRichTextBox.Rtf = textBox1.Text;
        }

    }
}
